/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: CloseMultiMap.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_CLOSE_MULTI_MAP_HPP_
#define _UTILITY_CLOSE_MULTI_MAP_HPP_

#include "tops/utilities/CloseContainer/CloseContainer.hpp"
#include "tops/utilities/CloseContainer/CloseRelationImpl.hpp"

#include <map>

namespace Utility {

	/**
	 * 密マルチマップテンプレートです。
	 * このテンプレートは、型引数にキー型と密コンテナ要素のポインタ型（スマートポインタ可）を必要とします。
	 * キー型には任意の型を指定できます。
	 * 密コンテナ要素のポインタ型に必要となる性質を以下に示します。
     *
     * 1. CloseContainerElement のポインタ（もしくはスマートポインタ）であること。
	 *
	 * この密マルチマップテンプレートは、実装に STL の std::multimap を利用しています。
	 *
	 * @author トゥイー
	 */
	template<typename KeyType, typename PtrType>
	class CloseMultiMap : public CloseContainer {
	private:
		typedef std::multimap<KeyType, PtrType> ValueMap;
		ValueMap m_values;
		typedef std::pair<KeyType, PtrType> ValuePair;

	public:
		/**
		 * 反復子型です。
		 */
		typedef typename ValueMap::iterator iterator;

		/**
		 * 定数反復子型です。
		 */
		typedef typename ValueMap::const_iterator const_iterator;

	public:
		/**
		 * マルチマップを構築します。
		 */
		CloseMultiMap() {
		}

		/**
		 * マルチマップを破棄します。
		 */
		~CloseMultiMap() {
			clear();
		}

	public:
		/**
		 * 空かどうかを判断します。
		 *
		 * @return 空の場合は true、それ以外の場合は false。
		 */
		bool empty() const {
			return m_values.empty();
		}

		/**
		 * キーの存在数を返します。
		 *
		 * @param key キー。
		 * @return キーの存在数。
		 */
		size_t count(const KeyType& key) const {
			return m_values.count(key);
		}

		/**
		 * サイズを取得します。
		 *
		 * @return サイズ。
		 */
		size_t size() const {
			return m_values.size();
		}

		/**
		 * 要素列の先頭を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator begin() {
			return m_values.begin();
		}

		/**
		 * 要素列の先頭を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator begin() const {
			return m_values.begin();
		}

		/**
		 * 要素列の末尾を示す反復子を取得します。
		 *
		 * @return 反復子。
		 */
		iterator end() {
			return m_values.end();
		}

		/**
		 * 要素列の末尾を示す定数反復子を取得します。
		 *
		 * @return 定数反復子。
		 */
		const_iterator end() const {
			return m_values.end();
		}

	public:
		/**
		 * 全ての要素を削除します。
		 */
		void clear() {
			while (!empty()) {
				iterator i = begin();
				i->second->release(*this);
			}
		}

	public:
		/**
		 * 要素を追加します。
		 *
		 * @param pair キーと値のペア。
		 */
		void insert(const ValuePair& pair) {
			iterator i = m_values.insert(pair);
			if (i->second) {
				addRelation(*i->second, CloseRelationPtr(new CloseRelationImpl<ValueMap>(
					m_values, i, this)));
			}
		}

		/**
		 * 要素を追加します。
		 *
		 * @param pos 要素を追加する際のヒント。
		 * @param pair キーと値のペア。
		 */
		void insert(iterator pos, const ValuePair& pair) {
			iterator i = m_values.insert(pos, pair);
			if (i->second) {
				addRelation(*i->second, CloseRelationPtr(new CloseRelationImpl<ValueMap>(
					m_values, i, this)));
			}
		}

		/**
		 * 指定されたキーに対応する範囲を取得します。
		 *
		 * @param key キー。
		 * @return 範囲の先頭と末尾を示す反復子のペア。
		 */
		std::pair<iterator, iterator> equal_range(const KeyType& key) {
			return m_values.equal_range(key);
		}

		/**
		 * 指定されたキーに対応する範囲を取得します。
		 *
		 * @param key キー。
		 * @return 範囲の先頭と末尾を示す定数反復子のペア。
		 */
		std::pair<const_iterator, const_iterator> equal_range(const KeyType& key) const {
			return m_values.equal_range(key);
		}

		/**
		 * 指定されたキーに対応する最初の要素を取得します。
		 *
		 * @param key キー。
		 * @return 反復子。要素が見つからなかった場合は end()。
		 */
		iterator lower_bound(const KeyType& key) {
			return m_values.lower_bound(key);
		}

		/**
		 * 指定されたキーに対応する最初の要素を取得します。
		 *
		 * @param key キー。
		 * @return 定数反復子。要素が見つからなかった場合は end()。
		 */
		const_iterator lower_bound(const KeyType& key) const {
			return m_values.lower_bound(key);
		}

		/**
		 * 指定されたキーより大きいキーに対応する最初の要素を取得します。
		 *
		 * @param key キー。
		 * @return 反復子。要素が見つからなかった場合は end()。
		 */
		iterator upper_bound(const KeyType& key) {
			return m_values.upper_bound(key);
		}

		/**
		 * 指定されたキーより大きいキーに対応する最初の要素を取得します。
		 *
		 * @param key キー。
		 * @return 定数反復子。要素が見つからなかった場合は end()。
		 */
		const_iterator upper_bound(const KeyType& key) const {
			return m_values.upper_bound(key);
		}
	};

}  // namespace Utility

#endif
